// Example16Doc.cpp : implementation of the CExample16Doc class
//

#include "stdafx.h"
#include "Example16.h"

#include "Example16Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExample16Doc

IMPLEMENT_DYNCREATE(CExample16Doc, CDocument)

BEGIN_MESSAGE_MAP(CExample16Doc, CDocument)
	//{{AFX_MSG_MAP(CExample16Doc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExample16Doc construction/destruction

CExample16Doc::CExample16Doc()
{
	m_szTXTfname = _T("");

	m_dataflag = FALSE;
}

CExample16Doc::~CExample16Doc()
{
}

BOOL CExample16Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CExample16Doc serialization

void CExample16Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CExample16Doc diagnostics

#ifdef _DEBUG
void CExample16Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CExample16Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CExample16Doc commands

void CExample16Doc::OnFileOpen() 
{
	CFileDialog dlg(TRUE, _T("txt"), NULL,
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
		_T("Text Files (*.txt)|*.txt|All Files (*.*)|*.*||"));
	
	if (dlg.DoModal() == IDOK)
		{
		m_szTXTfname = dlg.GetFileName();

		SetTitle(m_szTXTfname);

		SetPathName(m_szTXTfname);

		BeginWaitCursor();

		m_dataflag = GetData();

		EndWaitCursor();

		UpdateAllViews(NULL);
		}
}

BOOL CExample16Doc::GetData()
{
	CStdioFile		f;
	CFileException  e;
	
	CString			szText;

	if( !f.Open( m_szTXTfname, CFile::modeRead | CFile::typeText | CFile::shareDenyNone, &e ) )
		{
		#ifdef _DEBUG
			afxDump << "File could not be opened " << e.m_cause << "\n";
		#endif
		return FALSE;
		}

	m_LineList.RemoveAll();

	while (f.ReadString(szText))
		{
		m_LineList.AddTail(szText);
		}

	f.Close();

	return TRUE;
}

void CExample16Doc::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_dataflag);	
}

void CExample16Doc::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_dataflag);
}

void CExample16Doc::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(FALSE);
}

BOOL CExample16Doc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	m_szTXTfname = lpszPathName;

	BeginWaitCursor();

	m_dataflag = GetData();

	EndWaitCursor();

	UpdateAllViews(NULL);
	
	return TRUE;
}
