// Example16View.h : interface of the CExample16View class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXAMPLE16VIEW_H__B07F0ECD_296C_11D3_8244_00207811603B__INCLUDED_)
#define AFX_EXAMPLE16VIEW_H__B07F0ECD_296C_11D3_8244_00207811603B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CExample16View : public CView
{
protected: // create from serialization only
	CFont*			m_pFont;
	CFont*			m_pPrintFont;
	CFontDialog*	m_pSetFont;
	CSize			m_DocSize;
	CSize			m_ViewCharSize;

// Added for printing
//*******************

	int	old_height;
	int old_topline;
	int old_margin;

	int	topline;

	CExample16View();
	DECLARE_DYNCREATE(CExample16View)

// Attributes
public:
	CFont			m_printerFont;
	int				m_cxLeftMargin;
	int				m_cyClient;
	int				m_iTopLine;
	int				m_clHeight;
	int				m_cyLineHeight;
	LOGFONT			m_lf;

	LPINT			m_pnTabs;
	BOOL			m_bTabs;

	CSize			GetCharSize() const {return m_ViewCharSize;}
	CSize			GetDocSize() const {return m_DocSize;}

	int				GetLinesPerPrintPage() const { return m_nLinesPerPrintPage; }
	int				GetPrintPageCount() const { return m_nPrintPages;}

	CMainFrame*		GetFrame(void);

	CExample16Doc*	GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExample16View)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CExample16View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CExample16View)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnViewFont();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int		m_iCurrLn;
	int		m_iCurrCol;
	BOOL	m_bInsurance;
	CRect	m_rectMargins;
	CRect	m_rectPrintable;
	CRect	m_rectHardwareMargins;
	CSize	m_sizePhysDev;
	CSize	m_sizeLogInch;
	int		fontpoint;
	int		prntLastLine;
	int		prntLine;
	BOOL	m_bNoFont;

	int		m_nPrintPages;
	int		m_nLinesPerPrintPage;
	CSize	m_PrintCharSize;

	void	ComputeViewMetrics(void);
	BOOL	CreateNewFont(void);
	void	ResetScrollValues(void);
	CFont*	GetFont(void);
	void	SetupPrinterFont(CDC *pDC, CPrintInfo* ptrinfo);
	void	CalculateMargins(CDC* pDC);
	void	ComputePrintMetrics(CPrintInfo* pInfo);
	CDC*	CreatePrinterDC();
	void	ComputePrintableLines(CDC* pDC, CPrintInfo* pInfo, int& nFirst, int& nLast);
};

#ifndef _DEBUG  // debug version in Example16View.cpp
inline CExample16Doc* CExample16View::GetDocument()
   { return (CExample16Doc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXAMPLE16VIEW_H__B07F0ECD_296C_11D3_8244_00207811603B__INCLUDED_)
